package de.firstdata.ipg.api.client.action.datastorage.object;

import de.firstdata.ipg.api.client.action.datastorage.HostedData;
import de.firstdata.ipg.api.client.action.object.IPGAPIActionObject;
import de.firstdata.ipg.api.schema.DataStorageItem;
import de.firstdata.ipg.api.schema.StoreHostedData;

abstract class HostedDataObject extends IPGAPIActionObject implements HostedData {

	protected HostedDataObject() {
		getStoreHostedData();
	}

	protected HostedDataObject(final String function, final String hostedDataID) {
		getItem(hostedDataID).setFunction(function);
	}

	@Override
	public void setStoreId(final String storeID) {
		getStoreHostedData().setStoreId(storeID);
	}

	@Override
	public StoreHostedData getStoreHostedData() {
		if (this.storeHostedData == null) {
			this.storeHostedData = new StoreHostedData();
		}
		return this.storeHostedData;
	}

	protected DataStorageItem getItem(final String hostedDataID) {
		final DataStorageItem item = new DataStorageItem();
		item.setHostedDataID(hostedDataID);
		getStoreHostedData().getDataStorageItem().add(item);
		return item;
	}
}
