package de.firstdata.ipg.api.client.action.object;

import java.util.Date;

import de.firstdata.ipg.api.client.action.GetExternalConsumerInformation;

public class GetExternalConsumerInformationObject extends IPGAPIActionObject implements GetExternalConsumerInformation {

	public GetExternalConsumerInformationObject(final String firstName, final String surname, final Date birthday, final String street,
			final String houseNumber, final String postCode, final String city, final String country, final String dataProvider) {
		this(firstName, surname, getFormattedDate(birthday), street, houseNumber, postCode, city, country, dataProvider);
	}

	public GetExternalConsumerInformationObject(final String firstName, final String surname, final String birthday, final String street,
			final String houseNumber, final String postCode, final String city, final String country, final String dataProvider) {
		final de.firstdata.ipg.api.schema.GetExternalConsumerInformation information = getGetExternalConsumerInformation();
		information.setBirthday(birthday);
		information.setCity(city);
		information.setCountry(country);
		information.setDataProvider(dataProvider);
		information.setFirstName(firstName);
		information.setHouseNumber(houseNumber);
		information.setPostCode(postCode);
		information.setStreet(street);
		information.setSurname(surname);
	}

	@Override
	public void setStoreId(final String value) {
		getGetExternalConsumerInformation().setStoreId(value);
	}

	@Override
	public void setOrderID(final String value) {
		getGetExternalConsumerInformation().setOrderId(value);
	}

	@Override
	public void setDisplayProcessorMessages(final boolean value) {
		getGetExternalConsumerInformation().setDisplayProcessorMessages(value);
	}

	@Override
	public de.firstdata.ipg.api.schema.GetExternalConsumerInformation getGetExternalConsumerInformation() {
		if (this.getExternalConsumerInformation == null) {
			this.getExternalConsumerInformation = new de.firstdata.ipg.api.schema.GetExternalConsumerInformation();
		}
		return this.getExternalConsumerInformation;
	}
}
