package de.firstdata.ipg.api.client.action.recurringpayment;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.creditcard.CreditCard;
import de.firstdata.ipg.api.client.transaction.dedirectdebit.DEDirectDebit;
import de.firstdata.ipg.api.client.transaction.setter.BasketSetter;
import de.firstdata.ipg.api.client.transaction.setter.BillingSetter;
import de.firstdata.ipg.api.client.transaction.setter.ShippingSetter;
import de.firstdata.ipg.api.schema.CardFunctionType;

public interface ModifyRecurringPayment extends RecurringPayment, BasketSetter, BillingSetter, ShippingSetter {

	void setAmount(final Amount value);

	void setCreditCard(final CreditCard value);

	void setDEDirectDebit(final DEDirectDebit value);

	void setHostedDataID(final String value);

	void setHostedDataStoreID(final String value);

	void setComments(final String value);

	void setInstallmentCount(final int value);

	void setInstallmentFrequency(final int value);

	void setInstallmentPeriod(final String value);

	void setMaximumFailures(final int value);

	void setRecurringStartDate(final String value);

	void setCardFunction(final CardFunctionType cardFunction);

}
