package de.firstdata.ipg.api.client.exception;

/**
 * An instance of this class is trown when finding problems in the client server
 * communication, e.g. in case of requesting a resource which cannot be found
 * (HTTP code <code>404</code>). Note that in case of an HTTP error code
 * <code>500</code>, a processing error has occured which results in a
 * {@link ProcessingException} to be thrown.
 *
 * @author Andreas Schmid
 *
 */
public class HttpException extends ServerException {

	private static final long serialVersionUID = 1L;

	/**
	 * creates an instance of this class taking an error description as argument
	 *
	 * @param message
	 *            a string describing the error
	 */
	public HttpException(final String message) {
		super(message);
	}
}
