package de.firstdata.ipg.api.client.transaction.dedirectdebit.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.dedirectdebit.DEDirectDebit;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.schema.DEDirectDebitData;
import de.firstdata.ipg.api.schema.DEDirectDebitTxType;

public abstract class DEDDTransactionObject extends IPGApiTransactionObject {

	protected DEDDTransactionObject(final String type, final Amount amount, final DEDirectDebit account, final String hostedDataID,
			final String hostedDataStoreID, final String orderID) {
		super(amount, hostedDataID, hostedDataStoreID, orderID);
		getDEDirectDebitTxType().setType(type);
		if (account == null) {
			return;
		}
		final DEDirectDebitData dDDE = new DEDirectDebitData();
		if (account.accountNumber != null && account.accountNumber.length() <= 12) {
			dDDE.setBankCode(account.bankCode);
			dDDE.setAccountNumber(account.accountNumber);
		} else {
			dDDE.setBIC(account.bic);
			dDDE.setIBAN(account.iban);
		}
		dDDE.setTrackData(account.trackData);
		setDEDirectDebitData(dDDE);
	}

	@Override
	public String getType() {
		return getDEDirectDebitTxType().getType();
	}

	@Override
	public void setStoreId(final String storeId) {
		getDEDirectDebitTxType().setStoreId(storeId);
	}

	@Override
	public DEDirectDebitTxType getDEDirectDebitTxType() {
		if (this.deDirectDebitTxType == null) {
			this.deDirectDebitTxType = new DEDirectDebitTxType();
		}
		return this.deDirectDebitTxType;
	}

	@Override
	public String getStore() {
		return getDEDirectDebitTxType().getStoreId();
	}
}
