package de.firstdata.ipg.api.client.transaction.topup.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.topup.MobilePhoneChargeTransaction;
import de.firstdata.ipg.api.schema.TopUpTxType;
import de.firstdata.ipg.api.schema.TopUpTxType.MPCharge;

public class MobilePhoneChargeTransactionObject extends TopUpTransactionObject implements MobilePhoneChargeTransaction {

	public MobilePhoneChargeTransactionObject(final Amount amount, final String mobileNetworkServiceProvider, final String mobilePhoneNumber,
			final String type) {
		super(amount);
		final MPCharge mpCharge = getMPCharge();
		mpCharge.setMNSP(mobileNetworkServiceProvider);
		mpCharge.setMSISDN(mobilePhoneNumber);
		mpCharge.setPaymentType(type);
	}

	@Override
	public String getType() {
		return "MobileTopUp";
	}

	private MPCharge getMPCharge() {
		final TopUpTxType topUpTxType = getTopUpTxType();
		MPCharge mpCharge = topUpTxType.getMPCharge();
		if (mpCharge == null) {
			mpCharge = new MPCharge();
			topUpTxType.setMPCharge(mpCharge);
		}
		return mpCharge;
	}
}
